Overview | Package | Class | Tree | Deprecated | Index | Help
| Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.springframework.orm.jpa
Class AbstractEntityManagerFactoryBean

    java.lang.Object
      org.springframework.orm.jpa.AbstractEntityManagerFactoryBean

All Implemented Interfaces:
  java.io.Serializable, Aware, BeanClassLoaderAware, BeanFactoryAware, BeanNameAware, DisposableBean, FactoryBean<javax.persistence.EntityManagerFactory>, InitializingBean, PersistenceExceptionTranslator, EntityManagerFactoryInfo

Direct Known Subclasses:
  LocalContainerEntityManagerFactoryBean, LocalEntityManagerFactoryBean

    public abstract class AbstractEntityManagerFactoryBean

extends java.lang.Object
implements FactoryBean<javax.persistence.EntityManagerFactory>, BeanClassLoaderAware, BeanFactoryAware, BeanNameAware, InitializingBean, DisposableBean, EntityManagerFactoryInfo, PersistenceExceptionTranslator, java.io.Serializable

Abstract `FactoryBean` that creates a local JPA `EntityManagerFactory` instance within a Spring application context.

Encapsulates the common functionality between the different JPA bootstrap contracts (standalone as well as container).

Implements support for standard JPA configuration as well as Spring's `JpaVendorAdapter` abstraction, and controls the EntityManagerFactory's lifecycle.

This class also implements the `PersistenceExceptionTranslator` interface, as autodetected by Spring's `PersistenceExceptionTranslationPostProcessor`, for AOP-based translation of native exceptions to Spring DataAccessExceptions. Hence, the presence of e.g. LocalEntityManagerFactoryBean automatically enables a PersistenceExceptionTranslationPostProcessor to translate JPA exceptions.

Since:
  2.0
Author:
  Juergen Hoeller, Rod Johnson
See Also:
  `LocalEntityManagerFactoryBean`, `LocalContainerEntityManagerFactoryBean`, Serialized Form

Field Summary
`protected org.apache.commons.logging.Log` | `logger` Logger available to subclasses
`javax.persistence.EntityManagerFactory` | `nativeEntityManagerFactory` Raw EntityManagerFactory as returned by the PersistenceProvider

Constructor Summary
`AbstractEntityManagerFactoryBean()`

Method Summary
`void` | `afterPropertiesSet()` Invoked by a BeanFactory after it has set all bean properties supplied (and satisfied BeanFactoryAware and ApplicationContextAware).
`protected javax.persistence.EntityManagerFactory` | `createEntityManagerFactoryProxy(javax.persistence.EntityManagerFactory emf)` Create a proxy of the given EntityManagerFactory.
`protected abstract javax.persistence.EntityManagerFactory` | `createNativeEntityManagerFactory()` Subclasses must implement this method to create the EntityManagerFactory that will be returned by the `getObject()` method.
`void` | `destroy()` Close the EntityManagerFactory on bean factory shutdown.
`java.lang.ClassLoader` | `getBeanClassLoader()` Return the ClassLoader that the application's beans are loaded with.
`javax.sql.DataSource` | `getDataSource()` Return the JDBC DataSource that this EntityManagerFactory obtains its JDBC Connections from.
`java.lang.Class<? extends javax.persistence.EntityManager>` | `getEntityManagerInterface()` Return the (potentially vendor-specific) EntityManager interface that this factory's EntityManagers will implement.
`JpaDialect` | `getJpaDialect()` Return the vendor-specific JpaDialect implementation for this EntityManagerFactory, or `null` if not known.
`java.util.Map<java.lang.String,java.lang.Object>` | `getJpaPropertyMap()` Allow Map access to the JPA properties to be passed to the persistence provider, with the option to add or override specific entries.
`JpaVendorAdapter` | `getJpaVendorAdapter()` Return the JpaVendorAdapter implementation for this EntityManagerFactory, or `null` if not known.
`javax.persistence.EntityManagerFactory` | `getNativeEntityManagerFactory()` Return the raw underlying EntityManagerFactory.
`javax.persistence.EntityManagerFactory` | `getObject()` Return the singleton EntityManagerFactory.
`java.lang.Class<? extends javax.persistence.EntityManagerFactory>` | `getObjectType()` Return the type of object that this FactoryBean creates, or `null` if not known in advance.
`javax.persistence.spi.PersistenceProvider` | `getPersistenceProvider()` Return the underlying PersistenceProvider that the underlying EntityManagerFactory was created with.
`javax.persistence.spi.PersistenceUnitInfo` | `getPersistenceUnitInfo()` Return the PersistenceUnitInfo used to create this EntityManagerFactory, if the in-container API was used.
`java.lang.String` | `getPersistenceUnitName()` Return the name of the persistence unit used to create this EntityManagerFactory, or `null` if it is an unnamed default.
`boolean` | `isSingleton()` Is the object managed by this factory a singleton? That is, will `FactoryBean.getObject()` always return the same object (a reference that can be cached)?
`void` | `setBeanClassLoader(java.lang.ClassLoader classLoader)` Callback that supplies the bean `class loader` to a bean instance.
`void` | `setBeanFactory(BeanFactory beanFactory)` Callback that supplies the owning factory to a bean instance.
`void` | `setBeanName(java.lang.String name)` Set the name of the bean in the bean factory that created this bean.
`void` | `setEntityManagerFactoryInterface(java.lang.Class<? extends javax.persistence.EntityManagerFactory> emfInterface)` Specify the (potentially vendor-specific) EntityManagerFactory interface that this EntityManagerFactory proxy is supposed to implement.
`void` | `setEntityManagerInterface(java.lang.Class<? extends javax.persistence.EntityManager> emInterface)` Specify the (potentially vendor-specific) EntityManager interface that this factory's EntityManagers are supposed to implement.
`void` | `setJpaDialect(JpaDialect jpaDialect)` Specify the vendor-specific JpaDialect implementation to associate with this EntityManagerFactory.
`void` | `setJpaProperties(java.util.Properties jpaProperties)` Specify JPA properties, to be passed into `Persistence.createEntityManagerFactory` (if any).
`void` | `setJpaPropertyMap(java.util.Map<java.lang.String,?> jpaProperties)` Specify JPA properties as a Map, to be passed into `Persistence.createEntityManagerFactory` (if any).
`void` | `setJpaVendorAdapter(JpaVendorAdapter jpaVendorAdapter)` Specify the JpaVendorAdapter implementation for the desired JPA provider, if any.
`void` | `setPersistenceProvider(javax.persistence.spi.PersistenceProvider persistenceProvider)` Set the PersistenceProvider instance to use for creating the EntityManagerFactory.
`void` | `setPersistenceProviderClass(java.lang.Class<? extends javax.persistence.spi.PersistenceProvider> persistenceProviderClass)` Set the PersistenceProvider implementation class to use for creating the EntityManagerFactory.
`void` | `setPersistenceUnitName(java.lang.String persistenceUnitName)` Specify the name of the EntityManagerFactory configuration.
`DataAccessException` | `translateExceptionIfPossible(java.lang.RuntimeException ex)` Implementation of the PersistenceExceptionTranslator interface, as autodetected by Spring's PersistenceExceptionTranslationPostProcessor.
`protected java.lang.Object` | `writeReplace()`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### logger

    protected final org.apache.commons.logging.Log logger

  Logger available to subclasses

### nativeEntityManagerFactory

    public javax.persistence.EntityManagerFactory nativeEntityManagerFactory

  Raw EntityManagerFactory as returned by the PersistenceProvider

Constructor Detail

### AbstractEntityManagerFactoryBean

    public AbstractEntityManagerFactoryBean()

Method Detail

### setPersistenceProviderClass

    public void setPersistenceProviderClass(java.lang.Class<? extends javax.persistence.spi.PersistenceProvider> persistenceProviderClass)

  Set the PersistenceProvider implementation class to use for creating the EntityManagerFactory. If not specified, the persistence provider will be taken from the JpaVendorAdapter (if any) or retrieved through scanning (as far as possible).

  See Also:
    `JpaVendorAdapter.getPersistenceProvider()`, `PersistenceProvider`, `Persistence`

### setPersistenceProvider

    public void setPersistenceProvider(javax.persistence.spi.PersistenceProvider persistenceProvider)

  Set the PersistenceProvider instance to use for creating the EntityManagerFactory. If not specified, the persistence provider will be taken from the JpaVendorAdapter (if any) or determined by the persistence unit deployment descriptor (as far as possible).

  See Also:
    `JpaVendorAdapter.getPersistenceProvider()`, `PersistenceProvider`, `Persistence`

### getPersistenceProvider

    public javax.persistence.spi.PersistenceProvider getPersistenceProvider()

  Description copied from interface: `EntityManagerFactoryInfo`
  Return the underlying PersistenceProvider that the underlying EntityManagerFactory was created with.

  Specified by:
    `getPersistenceProvider` in interface `EntityManagerFactoryInfo`
  Returns:
    the PersistenceProvider used to create this EntityManagerFactory, or `null` if the standard JPA provider autodetection process was used to configure the EntityManagerFactory

### setPersistenceUnitName

    public void setPersistenceUnitName(java.lang.String persistenceUnitName)

  Specify the name of the EntityManagerFactory configuration.

  Default is none, indicating the default EntityManagerFactory configuration. The persistence provider will throw an exception if ambiguous EntityManager configurations are found.

  See Also:
    `Persistence.createEntityManagerFactory(String)`

### getPersistenceUnitName

    public java.lang.String getPersistenceUnitName()

  Description copied from interface: `EntityManagerFactoryInfo`
  Return the name of the persistence unit used to create this EntityManagerFactory, or `null` if it is an unnamed default.

  If `getPersistenceUnitInfo()` returns non-null, the result of `getPersistenceUnitName()` must be equal to the value returned by `PersistenceUnitInfo.getPersistenceUnitName()`.

  Specified by:
    `getPersistenceUnitName` in interface `EntityManagerFactoryInfo`
  See Also:
    `EntityManagerFactoryInfo.getPersistenceUnitInfo()`, `PersistenceUnitInfo.getPersistenceUnitName()`

### setJpaProperties

    public void setJpaProperties(java.util.Properties jpaProperties)

  Specify JPA properties, to be passed into `Persistence.createEntityManagerFactory` (if any).

  Can be populated with a String "value" (parsed via PropertiesEditor) or a "props" element in XML bean definitions.

  See Also:
    `Persistence.createEntityManagerFactory(String, java.util.Map)`, `PersistenceProvider.createContainerEntityManagerFactory(javax.persistence.spi.PersistenceUnitInfo, java.util.Map)`

### setJpaPropertyMap

    public void setJpaPropertyMap(java.util.Map<java.lang.String,?> jpaProperties)

  Specify JPA properties as a Map, to be passed into `Persistence.createEntityManagerFactory` (if any).

  Can be populated with a "map" or "props" element in XML bean definitions.

  See Also:
    `Persistence.createEntityManagerFactory(String, java.util.Map)`, `PersistenceProvider.createContainerEntityManagerFactory(javax.persistence.spi.PersistenceUnitInfo, java.util.Map)`

### getJpaPropertyMap

    public java.util.Map<java.lang.String,java.lang.Object> getJpaPropertyMap()

  Allow Map access to the JPA properties to be passed to the persistence provider, with the option to add or override specific entries.

  Useful for specifying entries directly, for example via "jpaPropertyMap[myKey]".

### setEntityManagerFactoryInterface

    public void setEntityManagerFactoryInterface(java.lang.Class<? extends javax.persistence.EntityManagerFactory> emfInterface)

  Specify the (potentially vendor-specific) EntityManagerFactory interface that this EntityManagerFactory proxy is supposed to implement.

  The default will be taken from the specific JpaVendorAdapter, if any, or set to the standard `javax.persistence.EntityManagerFactory` interface else.

  See Also:
    `JpaVendorAdapter.getEntityManagerFactoryInterface()`

### setEntityManagerInterface

    public void setEntityManagerInterface(java.lang.Class<? extends javax.persistence.EntityManager> emInterface)

  Specify the (potentially vendor-specific) EntityManager interface that this factory's EntityManagers are supposed to implement.

  The default will be taken from the specific JpaVendorAdapter, if any, or set to the standard `javax.persistence.EntityManager` interface else.

  See Also:
    `JpaVendorAdapter.getEntityManagerInterface()`, `EntityManagerFactoryInfo.getEntityManagerInterface()`

### getEntityManagerInterface

    public java.lang.Class<? extends javax.persistence.EntityManager> getEntityManagerInterface()

  Description copied from interface: `EntityManagerFactoryInfo`
  Return the (potentially vendor-specific) EntityManager interface that this factory's EntityManagers will implement.

  A `null` return value suggests that autodetection is supposed to happen: either based on a target `EntityManager` instance or simply defaulting to `javax.persistence.EntityManager`.

  Specified by:
    `getEntityManagerInterface` in interface `EntityManagerFactoryInfo`

### setJpaDialect

    public void setJpaDialect(JpaDialect jpaDialect)

  Specify the vendor-specific JpaDialect implementation to associate with this EntityManagerFactory. This will be exposed through the EntityManagerFactoryInfo interface, to be picked up as default dialect by accessors that intend to use JpaDialect functionality.

  See Also:
    `EntityManagerFactoryInfo.getJpaDialect()`

### getJpaDialect

    public JpaDialect getJpaDialect()

  Description copied from interface: `EntityManagerFactoryInfo`
  Return the vendor-specific JpaDialect implementation for this EntityManagerFactory, or `null` if not known.

  Specified by:
    `getJpaDialect` in interface `EntityManagerFactoryInfo`

### setJpaVendorAdapter

    public void setJpaVendorAdapter(JpaVendorAdapter jpaVendorAdapter)

  Specify the JpaVendorAdapter implementation for the desired JPA provider, if any. This will initialize appropriate defaults for the given provider, such as persistence provider class and JpaDialect, unless locally overridden in this FactoryBean.

### getJpaVendorAdapter

    public JpaVendorAdapter getJpaVendorAdapter()

  Return the JpaVendorAdapter implementation for this EntityManagerFactory, or `null` if not known.

### setBeanClassLoader

    public void setBeanClassLoader(java.lang.ClassLoader classLoader)

  Description copied from interface: `BeanClassLoaderAware`
  Callback that supplies the bean `class loader` to a bean instance.

  Invoked after the population of normal bean properties but before an initialization callback such as `InitializingBean's` `InitializingBean.afterPropertiesSet()` method or a custom init-method.

  Specified by:
    `setBeanClassLoader` in interface `BeanClassLoaderAware`
  Parameters:
    `classLoader` - the owning class loader; may be `null` in which case a default `ClassLoader` must be used, for example the `ClassLoader` obtained via `ClassUtils.getDefaultClassLoader()`

### getBeanClassLoader

    public java.lang.ClassLoader getBeanClassLoader()

  Description copied from interface: `EntityManagerFactoryInfo`
  Return the ClassLoader that the application's beans are loaded with.

  Proxies will be generated in this ClassLoader.

  Specified by:
    `getBeanClassLoader` in interface `EntityManagerFactoryInfo`

### setBeanFactory

    public void setBeanFactory(BeanFactory beanFactory)

  Description copied from interface: `BeanFactoryAware`
  Callback that supplies the owning factory to a bean instance.

  Invoked after the population of normal bean properties but before an initialization callback such as `InitializingBean.afterPropertiesSet()` or a custom init-method.

  Specified by:
    `setBeanFactory` in interface `BeanFactoryAware`
  Parameters:
    `beanFactory` - owning BeanFactory (never `null`). The bean can immediately call methods on the factory.
  See Also:
    `BeanInitializationException`

### setBeanName

    public void setBeanName(java.lang.String name)

  Description copied from interface: `BeanNameAware`
  Set the name of the bean in the bean factory that created this bean.

  Invoked after population of normal bean properties but before an init callback such as `InitializingBean.afterPropertiesSet()` or a custom init-method.

  Specified by:
    `setBeanName` in interface `BeanNameAware`
  Parameters:
    `name` - the name of the bean in the factory. Note that this name is the actual bean name used in the factory, which may differ from the originally specified name: in particular for inner bean names, the actual bean name might have been made unique through appending "#..." suffixes. Use the `BeanFactoryUtils.originalBeanName(String)` method to extract the original bean name (without suffix), if desired.

### afterPropertiesSet

    public final void afterPropertiesSet()
                                  throws javax.persistence.PersistenceException

  Description copied from interface: `InitializingBean`
  Invoked by a BeanFactory after it has set all bean properties supplied (and satisfied BeanFactoryAware and ApplicationContextAware).

  This method allows the bean instance to perform initialization only possible when all bean properties have been set and to throw an exception in the event of misconfiguration.

  Specified by:
    `afterPropertiesSet` in interface `InitializingBean`
  Throws:
    `javax.persistence.PersistenceException`

### createEntityManagerFactoryProxy

    protected javax.persistence.EntityManagerFactory createEntityManagerFactoryProxy(javax.persistence.EntityManagerFactory emf)

  Create a proxy of the given EntityManagerFactory. We do this to be able to return transaction-aware proxies for application-managed EntityManagers, and to introduce the NamedEntityManagerFactory interface

  Parameters:
    `emf` - EntityManagerFactory as returned by the persistence provider
  Returns:
    proxy entity manager

### createNativeEntityManagerFactory

    protected abstract javax.persistence.EntityManagerFactory createNativeEntityManagerFactory()
                                                                                        throws javax.persistence.PersistenceException

  Subclasses must implement this method to create the EntityManagerFactory that will be returned by the `getObject()` method.

  Returns:
    EntityManagerFactory instance returned by this FactoryBean
  Throws:
    `javax.persistence.PersistenceException` - if the EntityManager cannot be created

### translateExceptionIfPossible

    public DataAccessException translateExceptionIfPossible(java.lang.RuntimeException ex)

  Implementation of the PersistenceExceptionTranslator interface, as autodetected by Spring's PersistenceExceptionTranslationPostProcessor.

  Uses the dialect's conversion if possible; otherwise falls back to standard JPA exception conversion.

  Specified by:
    `translateExceptionIfPossible` in interface `PersistenceExceptionTranslator`
  Parameters:
    `ex` - a RuntimeException thrown
  Returns:
    the corresponding DataAccessException (or `null` if the exception could not be translated, as in this case it may result from user code rather than an actual persistence problem)
  See Also:
    `PersistenceExceptionTranslationPostProcessor`, `PersistenceExceptionTranslator.translateExceptionIfPossible(java.lang.RuntimeException)`, `EntityManagerFactoryUtils.convertJpaAccessExceptionIfPossible(java.lang.RuntimeException)`

### getNativeEntityManagerFactory

    public javax.persistence.EntityManagerFactory getNativeEntityManagerFactory()

  Description copied from interface: `EntityManagerFactoryInfo`
  Return the raw underlying EntityManagerFactory.

  Specified by:
    `getNativeEntityManagerFactory` in interface `EntityManagerFactoryInfo`
  Returns:
    the unadorned EntityManagerFactory (never `null`)

### getPersistenceUnitInfo

    public javax.persistence.spi.PersistenceUnitInfo getPersistenceUnitInfo()

  Description copied from interface: `EntityManagerFactoryInfo`
  Return the PersistenceUnitInfo used to create this EntityManagerFactory, if the in-container API was used.

  Specified by:
    `getPersistenceUnitInfo` in interface `EntityManagerFactoryInfo`
  Returns:
    the PersistenceUnitInfo used to create this EntityManagerFactory, or `null` if the in-container contract was not used to configure the EntityManagerFactory

### getDataSource

    public javax.sql.DataSource getDataSource()

  Description copied from interface: `EntityManagerFactoryInfo`
  Return the JDBC DataSource that this EntityManagerFactory obtains its JDBC Connections from.

  Specified by:
    `getDataSource` in interface `EntityManagerFactoryInfo`
  Returns:
    the JDBC DataSource, or `null` if not known

### getObject

    public javax.persistence.EntityManagerFactory getObject()

  Return the singleton EntityManagerFactory.

  Specified by:
    `getObject` in interface `FactoryBean<javax.persistence.EntityManagerFactory>`
  Returns:
    an instance of the bean (can be `null`)
  See Also:
    `FactoryBeanNotInitializedException`

### getObjectType

    public java.lang.Class<? extends javax.persistence.EntityManagerFactory> getObjectType()

  Description copied from interface: `FactoryBean`
  Return the type of object that this FactoryBean creates, or `null` if not known in advance.

  This allows one to check for specific types of beans without instantiating objects, for example on autowiring.

  In the case of implementations that are creating a singleton object, this method should try to avoid singleton creation as far as possible; it should rather estimate the type in advance. For prototypes, returning a meaningful type here is advisable too.

  This method can be called before this FactoryBean has been fully initialized. It must not rely on state created during initialization; of course, it can still use such state if available.

  NOTE: Autowiring will simply ignore FactoryBeans that return `null` here. Therefore it is highly recommended to implement this method properly, using the current state of the FactoryBean.

  Specified by:
    `getObjectType` in interface `FactoryBean<javax.persistence.EntityManagerFactory>`
  Returns:
    the type of object that this FactoryBean creates, or `null` if not known at the time of the call
  See Also:
    `ListableBeanFactory.getBeansOfType(java.lang.Class)`

### isSingleton

    public boolean isSingleton()

  Description copied from interface: `FactoryBean`
  Is the object managed by this factory a singleton? That is, will `FactoryBean.getObject()` always return the same object (a reference that can be cached)?

  NOTE: If a FactoryBean indicates to hold a singleton object, the object returned from `getObject()` might get cached by the owning BeanFactory. Hence, do not return `true` unless the FactoryBean always exposes the same reference.

  The singleton status of the FactoryBean itself will generally be provided by the owning BeanFactory; usually, it has to be defined as singleton there.

  NOTE: This method returning `false` does not necessarily indicate that returned objects are independent instances. An implementation of the extended `SmartFactoryBean` interface may explicitly indicate independent instances through its `SmartFactoryBean.isPrototype()` method. Plain `FactoryBean` implementations which do not implement this extended interface are simply assumed to always return independent instances if the `isSingleton()` implementation returns `false`.

  Specified by:
    `isSingleton` in interface `FactoryBean<javax.persistence.EntityManagerFactory>`
  Returns:
    whether the exposed object is a singleton
  See Also:
    `FactoryBean.getObject()`, `SmartFactoryBean.isPrototype()`

### destroy

    public void destroy()

  Close the EntityManagerFactory on bean factory shutdown.

  Specified by:
    `destroy` in interface `DisposableBean`

### writeReplace

    protected java.lang.Object writeReplace()
                                     throws java.io.ObjectStreamException

  Throws:
    `java.io.ObjectStreamException`

Overview | Package | Class | Tree | Deprecated | Index | Help
| Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD